package rpc

import (
	"fmt"

	"git.loafle.net/commons_go/logging"
	"git.loafle.net/commons_go/rpc"
	crcwf "git.loafle.net/commons_go/rpc/connection/websocket/fasthttp"
	"git.loafle.net/commons_go/rpc/gateway"
	"git.loafle.net/commons_go/rpc/protocol"
	"git.loafle.net/commons_go/rpc/protocol/json"
)

func newGatewayRPCServletHandler() GatewayRPCServletHandler {
	sh := &GatewayRPCServletHandlers{}
	sh.RegisterCodec(json.Name, json.NewServerCodec())
	return sh
}

type GatewayRPCServletHandlers struct {
	gateway.ServletHandlers
	rpcIO crcwf.ServletHandlers
}

func (sh *GatewayRPCServletHandlers) ReadRequest(servletCTX rpc.ServletContext, codec protocol.ServerCodec, conn interface{}) (protocol.ServerRequestCodec, error) {
	return sh.rpcIO.ReadRequest(servletCTX, codec, conn)
}

func (sh *GatewayRPCServletHandlers) WriteResponse(servletCTX rpc.ServletContext, conn interface{}, requestCodec protocol.ServerRequestCodec, result interface{}, err error) error {
	return sh.rpcIO.WriteResponse(servletCTX, conn, requestCodec, result, err)
}

func (sh *GatewayRPCServletHandlers) WriteNotification(servletCTX rpc.ServletContext, conn interface{}, codec protocol.ServerCodec, method string, args []interface{}) error {
	return sh.rpcIO.WriteNotification(servletCTX, conn, codec, method, args)
}

func (sh *GatewayRPCServletHandlers) Invoke(servletCTX rpc.ServletContext, requestCodec protocol.RegistryCodec) (result interface{}, err error) {
	// md := metadata.Pairs(oogw.GRPCUserIDKey, servletCTX.GetAttribute(oogw.SocketIDKey).(string))
	// grpcCTX := metadata.NewOutgoingContext(context.Background(), md)

	params, err := requestCodec.Params()
	if nil != err {
		return nil, err
	}

	logging.Logger().Debug(fmt.Sprintf("method:%s, params:%v", requestCodec.Method(), params))
	// r, err := grpc.Exec(grpcCTX, requestCodec.Method(), params)
	// if err != nil {
	// 	return nil, err
	// }
	r := struct{}{}

	return r, nil
}

func (sh *GatewayRPCServletHandlers) Validate() {
	sh.ServletHandlers.Validate()

}
